Foxit PDF SDK

Public Member Functions | List of all members
com.foxit.sdk.pdf.FileSpec Class Reference
Inheritance diagram for com.foxit.sdk.pdf.FileSpec:

## Public Member Functions
| FileSpec (PDFDoc document) throws com.foxit.sdk.PDFException
| Constructor. More...
| FileSpec (PDFDoc document, PDFObject pdf_object) throws com.foxit.sdk.PDFException
| Constructor, from an existing file specification PDF object in a PDF document. More...
| FileSpec (FileSpec other)
| Constructor, with another file specification object. More...
synchronized void | delete ()
| Clean up related C++ resources immediately. More...
boolean | embed (String file_path) throws com.foxit.sdk.PDFException
| Embed the whole content of a file which is specified by file path. More...
boolean | embed (PDFObject pdf_object) throws com.foxit.sdk.PDFException
| (Only support in PDF 2.0) Embed the whole content of a PDF stream object or a PDF reference object which refers to a PDF stream object, when current file specification object is used as an associated file. More...
boolean | embed (StreamCallback stream) throws com.foxit.sdk.PDFException
| Embed a file by using com.foxit.sdk.common.fxcrt.StreamCallback . More...
boolean | exportToFile (String path) throws com.foxit.sdk.PDFException
| Export the file data that represented in current file specification directly into a file. More...
boolean | exportToFileStream (StreamCallback stream) throws com.foxit.sdk.PDFException
| Export the file data that represented in current file specification through a stream callback object. More...
int | getAssociteFileRelationship () throws com.foxit.sdk.PDFException
| (Only supported in PDF 2.0) Get the associated file relationship when current file specification is used as an associated file. More...
byte [] | getChecksum () throws com.foxit.sdk.PDFException
| Get the checksum for embedded file. More...
int | getCompressedEmbeddedFileSize () throws com.foxit.sdk.PDFException
| Get the compressed file size of embedded file. More...
DateTime | getCreationDateTime () throws com.foxit.sdk.PDFException
| Get creation date and time about when the embedded file was created. More...
String | getDescription () throws com.foxit.sdk.PDFException
| Get the descriptive text associated with current file specification. More...
PDFDictionary | getDict () throws com.foxit.sdk.PDFException
| Get the PDF dictionary of current file specification. More...
FileReaderCallback | getFileData () throws com.foxit.sdk.PDFException
| Get the file data of embedded file. More...
String | getFileName () throws com.foxit.sdk.PDFException
| Get the file name. More...
int | getFileSize () throws com.foxit.sdk.PDFException
| Get the size of embedded file (uncompressed file size). More...
DateTime | getModifiedDateTime () throws com.foxit.sdk.PDFException
| Get modified date and time about when the embedded file was last modified. More...
String | getSubtype () throws com.foxit.sdk.PDFException
| (Only support in PDF 2.0) Get the MIME type value for "Subtype" key for embedded file when current file specification is used as an associated file. More...
boolean | isEmbedded () throws com.foxit.sdk.PDFException
| Check whether current file specification object represents an embedded file or not. More...
boolean | isEmpty ()
| Check whether current object is empty or not. More...
void | setAssociteFileRelationship (int associfile_relationship) throws com.foxit.sdk.PDFException
| (Only supported in PDF 2.0) Set the associated file relationship when current file specification is used as an associated file. More...
void | setChecksum (byte[] checksum) throws com.foxit.sdk.PDFException
| Set the checksum for embedded file. (Not affect local file) More...
void | setCreationDateTime (DateTime date_time) throws com.foxit.sdk.PDFException
| Set the creation date and time for the embedded file. (Not affect local file) More...
void | setDescription (String description) throws com.foxit.sdk.PDFException
| Set the descriptive text associated with current file specification. More...
void | setFileName (String file_name) throws com.foxit.sdk.PDFException
| Set the file name. More...
void | setModifiedDateTime (DateTime date_time) throws com.foxit.sdk.PDFException
| Set last modified date and time for the embedded file. (Not affect local file) More...
void | setSubtype (String subtype) throws com.foxit.sdk.PDFException
| (Only support in PDF 2.0) Set the MIME type value for "Subtype" key for embedded file (Not affect local file) when current file specification is used as an associated file. More...
Public Member Functions inherited from com.foxit.sdk.common.Base
synchronized void | delete ()
| Clean up related C++ resources immediately. More...

## Detailed Description

A PDF file can refer to the contents of another file by using a file specification. File specification can simply represents the file path of another file, or represents the whole content of another file, which is embedded to current PDF file.

## Constructor & Destructor Documentation

## ◆ FileSpec() [1/3]

com.foxit.sdk.pdf.FileSpec.FileSpec | ( | PDFDoc | document | ) | throws com.foxit.sdk.PDFException

Constructor.

This constructor is to construct a new file specification object (without any data).

Parameters

  [in] | document | A valid PDF document object, to which the new file specification object will belongs.

## ◆ FileSpec() [2/3]

com.foxit.sdk.pdf.FileSpec.FileSpec | ( | PDFDoc | document,
|  | PDFObject | pdf_object
| ) |  | throws com.foxit.sdk.PDFException

Constructor, from an existing file specification PDF object in a PDF document.

Parameters

  [in] | document | A valid PDF document object, to which the file specification PDF object belongs.
  [in] | pdf_object | A valid PDF object which represents an existing file specification object in the PDF document. It should be either a dictionary object or a PDF reference object: If it is a PDF dictionary object, it should be a file specification dictionary. If it is a PDF reference object, it should refer to a file specification dictionary. This PDF object can be retrieved from com.foxit.sdk.pdf.objects.PDFNameTree in type com.foxit.sdk.pdf.objects.PDFNameTree.e_EmbeddedFiles .

## ◆ FileSpec() [3/3]

com.foxit.sdk.pdf.FileSpec.FileSpec | ( | FileSpec | other | ) |

Constructor, with another file specification object.

Parameters

  [in] | other | Another file specification object.

## Member Function Documentation

## ◆ delete()

synchronized void com.foxit.sdk.pdf.FileSpec.delete | ( |  | ) |

Clean up related C++ resources immediately.

Returns
  None.

Note
  Once this function is called, current object cannot be used anymore.

## ◆ embed() [1/3]

boolean com.foxit.sdk.pdf.FileSpec.embed | ( | String | file_path | ) | throws com.foxit.sdk.PDFException

Embed the whole content of a file which is specified by file path.

When this function succeeds, the whole content of specified file will be embedded to the PDF document that current file specification belongs to.

Parameters

  [in] | file_path | A full path of an existing local file.

Returns
  true means success, while false means failure.

## ◆ embed() [2/3]

boolean com.foxit.sdk.pdf.FileSpec.embed | ( | PDFObject | pdf_object | ) | throws com.foxit.sdk.PDFException

(Only support in PDF 2.0) Embed the whole content of a PDF stream object or a PDF reference object which refers to a PDF stream object, when current file specification object is used as an associated file.

When this function succeeds, the whole content of specified PDF stream object will be embedded to the PDF document that current file specification belongs to.

Parameters

  [in] | pdf_object | A valid PDF object. It should be either a PDF stream object or a PDF reference object which refers to a PDF stream object.

Returns
  true means success, while false means failure.

## ◆ embed() [3/3]

boolean com.foxit.sdk.pdf.FileSpec.embed | ( | StreamCallback | stream | ) | throws com.foxit.sdk.PDFException

Embed a file by using com.foxit.sdk.common.fxcrt.StreamCallback .

When this function succeeds, please keep input stream callback object valid until the PDF file (which current file specification belongs to) is saved or closed.

Parameters

  [in] | stream | A com.foxit.sdk.common.fxcrt.StreamCallback object which is implemented by user to read the file content.

Returns
  true means success, while false means failure.

## ◆ exportToFile()

boolean com.foxit.sdk.pdf.FileSpec.exportToFile | ( | String | path | ) | throws com.foxit.sdk.PDFException

Export the file data that represented in current file specification directly into a file.

Parameters

  [in] | path | A full path of a file to which the data will be saved.

Returns
  true means success, while false means failure.

## ◆ exportToFileStream()

boolean com.foxit.sdk.pdf.FileSpec.exportToFileStream | ( | StreamCallback | stream | ) | throws com.foxit.sdk.PDFException

Export the file data that represented in current file specification through a stream callback object.

Parameters

  [in] | stream | A com.foxit.sdk.common.fxcrt.StreamCallback object which is implemented by user to save the file data.

Returns
  true means success, while false means failure.

## ◆ getAssociteFileRelationship()

int com.foxit.sdk.pdf.FileSpec.getAssociteFileRelationship | ( |  | ) | throws com.foxit.sdk.PDFException

(Only supported in PDF 2.0) Get the associated file relationship when current file specification is used as an associated file.

Returns
  The associated file relationship. Please refer to values starting from com.foxit.sdk.pdf.AssociatedFiles.e_RelationshipSource and this should be one of these values.

## ◆ getChecksum()

byte[] com.foxit.sdk.pdf.FileSpec.getChecksum | ( |  | ) | throws com.foxit.sdk.PDFException

Get the checksum for embedded file.

This function is only useful when current file specification object represents an embedded file. A 16-byte string that is the checksum of the bytes of the uncompressed embedded file. The checksum is calculated by applying the standard MD5 message-digest algorithm to the bytes of the embedded file stream.
If current file specification object does not represent an embedded file, this function will return an empty string.

Returns
  The checksum string.

## ◆ getCompressedEmbeddedFileSize()

int com.foxit.sdk.pdf.FileSpec.getCompressedEmbeddedFileSize | ( |  | ) | throws com.foxit.sdk.PDFException

Get the compressed file size of embedded file.

This function is only useful when current file specification object represents an embedded file. If current file specification object does not represent an embedded file, this function will return 0 directly.

Returns
  Compressied file size of embedded file.

## ◆ getCreationDateTime()

DateTime com.foxit.sdk.pdf.FileSpec.getCreationDateTime | ( |  | ) | throws com.foxit.sdk.PDFException

Get creation date and time about when the embedded file was created.

This function is only useful when current file specification object represents an embedded file. If current file specification object does not represent an embedded file, this function will return a date and time object will all value 0.

Returns
  The creation date time of embedded file.

## ◆ getDescription()

String com.foxit.sdk.pdf.FileSpec.getDescription | ( |  | ) | throws com.foxit.sdk.PDFException

Get the descriptive text associated with current file specification.

Returns
  The descriptive text.

## ◆ getDict()

PDFDictionary com.foxit.sdk.pdf.FileSpec.getDict | ( |  | ) | throws com.foxit.sdk.PDFException

Get the PDF dictionary of current file specification.

Returns
  A PDF dictionary object. If there is any error, this function will return null.

## ◆ getFileData()

FileReaderCallback com.foxit.sdk.pdf.FileSpec.getFileData | ( |  | ) | throws com.foxit.sdk.PDFException

Get the file data of embedded file.

Returns
  A com.foxit.sdk.common.fxcrt.FileReaderCallback object. User can call functions in class com.foxit.sdk.common.fxcrt.FileReaderCallback to read the file data.

## ◆ getFileName()

String com.foxit.sdk.pdf.FileSpec.getFileName | ( |  | ) | throws com.foxit.sdk.PDFException

Get the file name.

Returns
  The file name. If no file name can be found, this function will return an empty string.

## ◆ getFileSize()

int com.foxit.sdk.pdf.FileSpec.getFileSize | ( |  | ) | throws com.foxit.sdk.PDFException

Get the size of embedded file (uncompressed file size).

This function is only useful when current file specification object represents an embedded file. If current file specification object does not represent an embedded file, this function will return 0 directly.

Returns
  File size of embedded file (uncompressed file size).

## ◆ getModifiedDateTime()

DateTime com.foxit.sdk.pdf.FileSpec.getModifiedDateTime | ( |  | ) | throws com.foxit.sdk.PDFException

Get modified date and time about when the embedded file was last modified.

This function is only useful when current file specification object represents an embedded file. If current file specification object does not represent an embedded file, this function will return a date and time object will all value 0.

Returns
  The modified date time of embedded file.

## ◆ getSubtype()

String com.foxit.sdk.pdf.FileSpec.getSubtype | ( |  | ) | throws com.foxit.sdk.PDFException

(Only support in PDF 2.0) Get the MIME type value for "Subtype" key for embedded file when current file specification is used as an associated file.

This function is only useful when current file specification object represents an embedded file and used as associated file.

Returns
  The subtype string.

## ◆ isEmbedded()

boolean com.foxit.sdk.pdf.FileSpec.isEmbedded | ( |  | ) | throws com.foxit.sdk.PDFException

Check whether current file specification object represents an embedded file or not.

Returns
  true means current file specification object represents an embedded file. false means current file specification object does not represent an embedded file.

## ◆ isEmpty()

boolean com.foxit.sdk.pdf.FileSpec.isEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ setAssociteFileRelationship()

void com.foxit.sdk.pdf.FileSpec.setAssociteFileRelationship | ( | int | associfile_relationship | ) | throws com.foxit.sdk.PDFException

(Only supported in PDF 2.0) Set the associated file relationship when current file specification is used as an associated file.

This function is required for a newly created associated file specification object.

Parameters

  [in] | associfile_relationship | The associated file relationship to be set. Please refer to values starting from com.foxit.sdk.pdf.AssociatedFiles.e_RelationshipSource and this would be one of these values.

Returns
  None.

## ◆ setChecksum()

void com.foxit.sdk.pdf.FileSpec.setChecksum | ( | byte [] | checksum | ) | throws com.foxit.sdk.PDFException

Set the checksum for embedded file. (Not affect local file)

This function is only useful if current file specification object represents an embedded file.
A 16-byte string that is the checksum of the bytes of the uncompressed embedded file. The checksum is calculated by applying the standard MD5 message-digest algorithm to the bytes of the embedded file stream.

Parameters

  [in] | checksum | A checksum to be set.

Returns
  None.

## ◆ setCreationDateTime()

void com.foxit.sdk.pdf.FileSpec.setCreationDateTime | ( | DateTime | date_time | ) | throws com.foxit.sdk.PDFException

Set the creation date and time for the embedded file. (Not affect local file)

This function is only useful when current file specification object represents an embedded file.

Parameters

  [in] | date_time | The creation date and time to be set.

Returns
  None.

## ◆ setDescription()

void com.foxit.sdk.pdf.FileSpec.setDescription | ( | String | description | ) | throws com.foxit.sdk.PDFException

Set the descriptive text associated with current file specification.

Parameters

  [in] | description | A descriptive text to be set. It should not be an empty string.

Returns
  None.

## ◆ setFileName()

void com.foxit.sdk.pdf.FileSpec.setFileName | ( | String | file_name | ) | throws com.foxit.sdk.PDFException

Set the file name.

This function is required for a new file specification object (not constructed from an existing file specification PDF object).

Parameters

  [in] | file_name | The file name to be set. It should not be an empty string.

Returns
  None.

## ◆ setModifiedDateTime()

void com.foxit.sdk.pdf.FileSpec.setModifiedDateTime | ( | DateTime | date_time | ) | throws com.foxit.sdk.PDFException

Set last modified date and time for the embedded file. (Not affect local file)

This function is only useful when current file specification object represents an embedded file.

Parameters

  [in] | date_time | The last modified date and time to be set.

Returns
  None.

## ◆ setSubtype()

void com.foxit.sdk.pdf.FileSpec.setSubtype | ( | String | subtype | ) | throws com.foxit.sdk.PDFException

(Only support in PDF 2.0) Set the MIME type value for "Subtype" key for embedded file (Not affect local file) when current file specification is used as an associated file.

This function is only useful when current file specification object represents an embedded file and used as associated file.

Parameters

  [in] | subtype | A valid MIME type value. Default value: "application/octet-stream".

Returns
  None.